︠345a8394-38dd-4ec7-b322-20690f4836f5︠
p = complex_plot(lambda z: z^2-1, (-2, 2), (-2, 2))
︡c3e320c4-568e-4c90-9c53-4a11cdb276fa︡︡
︠faf03386-e6c2-4bfb-a1a7-a8c9372f37c9︠
p.show()
︡47c11af8-cf9b-4722-aa96-43f2fbad482c︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠e02a2c7a-4eb9-4409-aba0-7b4f2937285f︠
complex_plot(lambda z: log((1+z)/(1-z)), (-2, 2), (-2, 2))
︡6e666b77-f22a-4c82-9d56-06392b62166f︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠3d359ec2-cfa7-4b6b-969e-ed74f211969b︠
def graph_r(r):
    var('theta,z,u,v,w')
    z = r * e^(i * theta)
    w = log((1 + z)/(1 - z))
    u = log((1 + r^2 + 2*r*cos(theta))/(1 + r^2 - 2*r*cos(theta))) / 2
    v = arctan(sin(theta) * 2*r / (1 - r^2))
    p  = parametric_plot( (theta, u), (theta, -pi, pi), color='blue' )
    p += parametric_plot( (theta, v), (theta, -pi, pi), color='red' )
    p.show()
    err = integrate(abs(u + i*v - w), theta, -pi, pi).n()
    print "error =", err

graph_r(2)
︡3e04d943-e8a0-43f4-ae82-3a6c0e253425︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 19.7392088021787"}︡
︠92259527-1d19-4bea-b9c2-e336ca78be46︠
var('r,theta,z,u,v,w')
z = r * e^(i * theta)
w = log((1 + z)/(1 - z))
w.real()
︡f4d5a48b-94f4-4f91-8b58-030cd5923732︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\log\\left({\\left| -\\frac{r e^{\\left(i \\, \\theta\\right)} + 1}{r e^{\\left(i \\, \\theta\\right)} - 1} \\right|}\\right)</span>"}︡
︠a1fa9d9c-d892-4e67-b1d0-15bb2cb5fda5︠
w.real().simplify()
︡a66094e8-786f-46dd-872c-ec8e70684150︡{"stdout": "<html><span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\log\\left(\\frac{\\sqrt{r^{2} \\sin\\left(\\theta\\right)^{2} + {\\left(r \\cos\\left(\\theta\\right) + 1\\right)}^{2"}︡
︠314d78cf-cf3f-42ac-b752-4fd457e08043i︠
%html
\sqrt{r^{2} \sin\left(\theta\right)^{2} + {\left(r \cos\left(\theta\right) - 1\right)}^{2}}}\right)</span></html>
}}}

︡96b1dfcc-fca9-48ab-a101-fb2082a3feba︡{"html": "\\sqrt{r^{2} \\sin\\left(\\theta\\right)^{2} + {\\left(r \\cos\\left(\\theta\\right) - 1\\right)}^{2}}}\\right)</span></html>\n}}}"}︡
︠87a65f5e-f29a-49f3-a4bf-3ba63cd405fc︠
w.real().simplify_full()
︡82ac210e-c738-4cc1-9275-6c3384ad674a︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-\\frac{1}{2} \\, \\log\\left(r^{2} - 2 \\, r \\cos\\left(\\theta\\right) + 1\\right) + \\frac{1}{2} \\, \\log\\left(r^{2} + 2 \\, r \\cos\\left(\\theta\\right) + 1\\right)</span>"}︡
︠24121909-d768-4fd3-b4f4-cd31aa28c698︠
w.imag()
︡c40a450b-ebaa-4fbd-b268-4ed825c1027c︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\arctan\\left(\\frac{2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right) \\Re \\left( r \\right)}{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right) \\Im \\left( r \\right) - 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right) \\Re \\left( r \\right) + 1} + \\frac{2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right) \\Im \\left( r \\right)}{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right) \\Im \\left( r \\right) - 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right) \\Re \\left( r \\right) + 1}, -\\frac{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2}}{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right) \\Im \\left( r \\right) - 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right) \\Re \\left( r \\right) + 1} - \\frac{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2}}{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right) \\Im \\left( r \\right) - 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right) \\Re \\left( r \\right) + 1} - \\frac{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2}}{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right) \\Im \\left( r \\right) - 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right) \\Re \\left( r \\right) + 1} - \\frac{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2}}{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right) \\Im \\left( r \\right) - 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right) \\Re \\left( r \\right) + 1} + \\frac{1}{e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Re \\left( r \\right)^{2} + e^{\\left(-2 \\, \\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right)^{2} \\Im \\left( r \\right)^{2} + 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\sin\\left(\\Re \\left( \\theta \\right)\\right) \\Im \\left( r \\right) - 2 \\, e^{\\left(-\\Im \\left( \\theta \\right)\\right)} \\cos\\left(\\Re \\left( \\theta \\right)\\right) \\Re \\left( r \\right) + 1}\\right)</span>"}︡
︠f501a783-3129-4382-9030-c02f7e9ba9e3︠
w.imag().simplify()
︡dcf01818-8ca2-4c06-a783-37f20729fe5e︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\arctan\\left(\\frac{2 \\, r \\sin\\left(\\theta\\right)}{r^{2} \\sin\\left(\\theta\\right)^{2} + r^{2} \\cos\\left(\\theta\\right)^{2} - 2 \\, r \\cos\\left(\\theta\\right) + 1}, -\\frac{r^{2} \\sin\\left(\\theta\\right)^{2}}{r^{2} \\sin\\left(\\theta\\right)^{2} + r^{2} \\cos\\left(\\theta\\right)^{2} - 2 \\, r \\cos\\left(\\theta\\right) + 1} - \\frac{r^{2} \\cos\\left(\\theta\\right)^{2}}{r^{2} \\sin\\left(\\theta\\right)^{2} + r^{2} \\cos\\left(\\theta\\right)^{2} - 2 \\, r \\cos\\left(\\theta\\right) + 1} + \\frac{1}{r^{2} \\sin\\left(\\theta\\right)^{2} + r^{2} \\cos\\left(\\theta\\right)^{2} - 2 \\, r \\cos\\left(\\theta\\right) + 1}\\right)</span>"}︡
︠b90cbb8d-be3b-4add-b054-8933adb5ccc4︠
w.imag().simplify_full()
︡b550fe04-6748-4bfe-823d-4949395ec180︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-\\arctan\\left(-\\frac{2 \\, r \\sin\\left(\\theta\\right)}{r^{2} - 2 \\, r \\cos\\left(\\theta\\right) + 1}, -\\frac{r^{2} - 1}{r^{2} - 2 \\, r \\cos\\left(\\theta\\right) + 1}\\right)</span>"}︡
︠3ee74108-1f19-45f0-b97f-b4b26f485a2a︠
def gr(r):
    var('theta,z,u,v,v1,v2,w'); assume(theta,'real')
    z = r * e^(i * theta)
    w = log((1 + z)/(1 - z))
    u = log((1 + r^2 + 2*r*cos(theta))/(1 + r^2 - 2*r*cos(theta))) / 2
    v = w.imag()
    v1 = arctan(sin(theta) * 2*r / (1 - r^2)) + pi * sign(theta) * (1 - floor(1/(1 + floor(r))))
    p  = parametric_plot( (theta,  u), (theta, -pi, pi), color='blue' )
    p += parametric_plot( (theta,  v), (theta, -pi, pi), color='black')
    p += parametric_plot( (theta, v1), (theta, -pi, pi), color='red'  )
    p.show()
    #err = numerical_integral(abs(u + i*v1 - w), theta, -pi, pi).n()
    #e0 = numerical_integral(abs(u.imag()),     theta, -pi, pi).n()
    #e1 = numerical_integral(abs(u - w.real()), theta, -pi, pi).n()
    #e2 = numerical_integral(abs(v1- w.imag()), theta, -pi, pi).n()
    err = (sum(abs(u + i*v1 - w).function(theta)(t*pi) for t in range(1,100))/100).simplify_full()
    print "error =", err # there appears to be some error at theta=0
gr(2)
︡70d41a0e-d22f-457f-bda5-2d870af00282︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 0"}︡
︠180b17bb-47f3-40dc-95d1-e471fa49919c︠
gr(3)
︡6c9a87dc-9c5e-432f-9d93-11032ea06e50︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 1/100*pi"}︡
︠1bd83597-c7a0-4a8f-a92a-fd05517a5ec6︠
gr(10)
︡8da7de10-6496-4902-a973-63e89319c112︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 0"}︡
︠3d7548bd-e8d8-40e3-9184-cc9dd4e54926︠
gr(1.1)
︡04a32bf7-8931-4d13-bc92-620c09e27eb7︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 0.99*I*pi - 1.15463194561e-16 - 3.11017672705*I"}︡
︠306438dd-36b6-4930-9007-65d2c215e508︠
gr(1.01)
︡04598930-7ef4-4779-a28b-e7910366d2e7︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 0.99*I*pi + 1.05426778418e-14 - 3.11017672705*I"}︡
︠aea472ed-2421-467d-9b2a-19b424def575︠
gr(1.001)
︡d9c90a51-6716-4009-b54e-65ba2f7f689b︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 0.99*I*pi + 6.99991176134e-13 - 3.11017672705*I"}︡
︠c4de10d3-26c8-4c72-b0e1-b49ec0a06a19︠
gr(.9)
︡e96345fb-41a4-42c3-9529-c8d13073c62f︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 4.39648317752e-16"}︡
︠9872c8b1-896c-4508-826e-cb28d4971877︠
gr(.7)
︡e5d9ab47-8bb0-46c9-9b43-090b87e55f2f︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 3.28626015289e-16"}︡
︠a30bc1fe-b2e9-4c85-89a2-885f08e8f0d0︠
gr(.5)
︡f1cfe73d-6e28-4b95-8690-a6ee86946c2c︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 0"}︡
︠380dcd9a-6cd5-4a60-9a54-abf6f4ffc5db︠
gr(.2)
︡f1262248-561c-42af-bc02-e91ed61954da︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 5.55111512313e-17"}︡
︠e69d638b-fa50-4e2b-8742-a18e777275c8︠
gr(.1)
︡8c7a0595-1539-40ca-aa71-1f6cf9239a45︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 1.24067423002e-16"}︡
︠180d4394-b323-48c8-843c-91b95d3668e7︠
gr(3)
︡c4acd750-ee2d-4cee-bd23-4686383da34a︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 0"}︡
︠3874828f-20da-4a07-843f-4ab86b3c5955︠
gr(10)
︡d7640657-6a71-495d-ab86-b1cf59843841︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"stdout": "error = 0"}︡
︠6ff1bd18-5501-4bc0-a153-6828a22ab460︠
var('r,theta,z,u,v,w'); assume(r,'real'); assume(theta,'real')
z = r * e^(i * theta)
w = log((1 + z)/(1 - z))
w.imag().simplify_full()
︡32efa854-823f-4996-8016-b5ccd988ca30︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-\\arctan\\left(-\\frac{2 \\, r \\sin\\left(\\theta\\right)}{r^{2} - 2 \\, r \\cos\\left(\\theta\\right) + 1}, -\\frac{r^{2} - 1}{r^{2} - 2 \\, r \\cos\\left(\\theta\\right) + 1}\\right)</span>"}︡
︠c9927139-2f1e-449d-8895-ad505987ff3a︠
tan(w.imag()).simplify_full()
︡da7746ca-e44d-4201-96bd-5c7f086eb616︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-\\frac{2 \\, r \\sin\\left(\\theta\\right)}{r^{2} - 1}</span>"}︡
︠7b938848-a59e-411b-ad01-a457b4ef85be︠
e^w.real()*cos(w.imag()).simplify_full()
︡d2bdaab4-fc0b-49ac-b3ba-a6dd38aee86f︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-\\frac{{\\left(r^{2} - 1\\right)} {\\left| -\\frac{r e^{\\left(i \\, \\theta\\right)} + 1}{r e^{\\left(i \\, \\theta\\right)} - 1} \\right|}}{\\sqrt{r^{2} - 2 \\, r \\cos\\left(\\theta\\right) + 1} \\sqrt{r^{2} + 2 \\, r \\cos\\left(\\theta\\right) + 1}}</span>"}︡
︠bb961eed-4924-4ecf-9577-222842d19480︠
((r*e^(i*theta)+1)/(r*e^(i*theta)-1)).simplify_full()
︡75c620a4-d778-4453-9eab-50e2427752ab︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\frac{r e^{\\left(i \\, \\theta\\right)} + 1}{r e^{\\left(i \\, \\theta\\right)} - 1}</span>"}︡
︠c9a36cbd-5fda-41e8-9655-734aabb8bff3︠
abs(r*e^(i*theta)+1).simplify_full()
︡bca7a087-23fe-4f78-a5c4-9da6decbd209︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\sqrt{r^{2} + 2 \\, r \\cos\\left(\\theta\\right) + 1}</span>"}︡
